import { ElementRef } from '@angular/core';
import { AnyRouter, Constrain, InferFrom, InferMaskFrom, InferMaskTo, InferTo, LinkOptions, RegisteredRouter } from '@tanstack/router-core';
import * as i0 from "@angular/core";
export declare class Link {
    linkOptions: import("@angular/core").InputSignalWithTransform<Omit<LinkOptions, "activeOptions"> & {
        activeOptions?: LinkOptions["activeOptions"] & {
            class?: string;
        };
    }, any>;
    linkActiveOptions: import("@angular/core").InputSignalWithTransform<import("tanstack-angular-router-experimental").ActiveOptions & {
        class?: string;
    }, string | (import("tanstack-angular-router-experimental").ActiveOptions & {
        class?: string;
    })>;
    private router;
    hostElement: ElementRef<HTMLAnchorElement>;
    private currentSearch;
    protected disabled: import("@angular/core").Signal<boolean | undefined>;
    private to;
    private userFrom;
    private userReloadDocument;
    private userPreload;
    private userPreloadDelay;
    private activeOptions;
    private exactActiveOptions;
    private includeHashActiveOptions;
    private includeSearchActiveOptions;
    protected type: import("@angular/core").Signal<"external" | "internal">;
    protected from: import("@angular/core").Signal<string | import("tanstack-angular-router-experimental").TanstackRouteMatch<any, any, any, any, any, any, any>[] | undefined>;
    private navigateOptions;
    private next;
    private preload;
    private preloadDelay;
    protected hostHref: import("@angular/core").Signal<any>;
    transitioning: import("@angular/core").WritableSignal<boolean>;
    isActive: import("@angular/core").Signal<boolean | undefined>;
    protected activeClass: import("@angular/core").Signal<string>;
    constructor();
    protected handleClick(event: MouseEvent): void;
    protected handleFocus(): void;
    private preloadTimeout;
    protected handleMouseEnter(event: MouseEvent): void;
    protected handleMouseLeave(): void;
    private doPreload;
    private isCtrlEvent;
    static ɵfac: i0.ɵɵFactoryDeclaration<Link, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<Link, "a[link]", ["link"], { "linkOptions": { "alias": "link"; "required": true; "isSignal": true; }; "linkActiveOptions": { "alias": "linkActive"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
export type ValidateLinkOptions<TRouter extends AnyRouter = RegisteredRouter, TOptions = unknown, TDefaultFrom extends string = string> = Constrain<TOptions, Omit<LinkOptions<TRouter, InferFrom<TOptions, TDefaultFrom>, InferTo<TOptions>, InferMaskFrom<TOptions>, InferMaskTo<TOptions>>, 'activeOptions'> & Partial<Omit<HTMLAnchorElement, 'search'>> & {
    label?: string | (() => string);
    activeOptions?: LinkOptions<TRouter, InferFrom<TOptions, TDefaultFrom>, InferTo<TOptions>, InferMaskFrom<TOptions>, InferMaskTo<TOptions>>['activeOptions'] & {
        class?: string;
    };
}>;
export type ValidateLinkOptionsArray<TRouter extends AnyRouter = RegisteredRouter, TOptions extends ReadonlyArray<any> = ReadonlyArray<unknown>, TDefaultFrom extends string = string> = {
    [K in keyof TOptions]: ValidateLinkOptions<TRouter, TOptions[K], TDefaultFrom>;
};
export type LinkOptionsFnOptions<TOptions, TRouter extends AnyRouter = RegisteredRouter> = TOptions extends ReadonlyArray<any> ? ValidateLinkOptionsArray<TRouter, TOptions> : ValidateLinkOptions<TRouter, TOptions>;
export type LinkOptionsFn = <const TOptions, TRouter extends AnyRouter = RegisteredRouter>(options: LinkOptionsFnOptions<TOptions, TRouter>) => TOptions;
export declare const linkOptions: LinkOptionsFn;
