import { Injector, Signal } from '@angular/core';
import { AnyRouter, RegisteredRouter, ResolveUseLoaderData, StrictOrFrom, UseLoaderDataResult } from '@tanstack/router-core';
import { Observable } from 'rxjs';
export interface LoaderDataBaseOptions<TRouter extends AnyRouter, TFrom, TStrict extends boolean, TSelected> {
    select?: (match: ResolveUseLoaderData<TRouter, TFrom, TStrict>) => TSelected;
    injector?: Injector;
}
export type LoaderDataOptions<TRouter extends AnyRouter, TFrom extends string | undefined, TStrict extends boolean, TSelected> = StrictOrFrom<TRouter, TFrom, TStrict> & LoaderDataBaseOptions<TRouter, TFrom, TStrict, TSelected>;
export type LoaderDataRoute<TObservable extends boolean, out TId> = <TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>(opts?: LoaderDataBaseOptions<TRouter, TId, true, TSelected>) => TObservable extends true ? Observable<UseLoaderDataResult<TRouter, TId, true, TSelected>> : Signal<UseLoaderDataResult<TRouter, TId, true, TSelected>>;
export declare function loaderData$<TRouter extends AnyRouter = RegisteredRouter, const TFrom extends string | undefined = undefined, TStrict extends boolean = true, TSelected = unknown>({ injector, ...opts }: LoaderDataOptions<TRouter, TFrom, TStrict, TSelected>): Observable<UseLoaderDataResult<TRouter, TFrom, TStrict, TSelected>>;
export declare function loaderData<TRouter extends AnyRouter = RegisteredRouter, const TFrom extends string | undefined = undefined, TStrict extends boolean = true, TSelected = unknown>({ injector, ...opts }: LoaderDataOptions<TRouter, TFrom, TStrict, TSelected>): Signal<UseLoaderDataResult<TRouter, TFrom, TStrict, TSelected>>;
