import { Injector, Signal } from '@angular/core';
import { AnyRouter, RegisteredRouter, ResolveUseLoaderDeps, StrictOrFrom, UseLoaderDepsResult } from '@tanstack/router-core';
import { Observable } from 'rxjs';
export interface LoaderDepsBaseOptions<TRouter extends AnyRouter, TFrom, TSelected> {
    select?: (deps: ResolveUseLoaderDeps<TRouter, TFrom>) => TSelected;
    injector?: Injector;
}
export type LoaderDepsOptions<TRouter extends AnyRouter, TFrom extends string | undefined, TSelected> = StrictOrFrom<TRouter, TFrom> & LoaderDepsBaseOptions<TRouter, TFrom, TSelected>;
export type LoaderDepsRoute<TObservable extends boolean, out TId> = <TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>(opts?: LoaderDepsBaseOptions<TRouter, TId, TSelected>) => TObservable extends true ? Observable<UseLoaderDepsResult<TRouter, TId, TSelected>> : Signal<UseLoaderDepsResult<TRouter, TId, TSelected>>;
export declare function loaderDeps$<TRouter extends AnyRouter = RegisteredRouter, const TFrom extends string | undefined = undefined, TSelected = unknown>({ injector, ...opts }: LoaderDepsOptions<TRouter, TFrom, TSelected>): Observable<UseLoaderDepsResult<TRouter, TFrom, TSelected>>;
export declare function loaderDeps<TRouter extends AnyRouter = RegisteredRouter, const TFrom extends string | undefined = undefined, TSelected = unknown>({ injector, ...opts }: LoaderDepsOptions<TRouter, TFrom, TSelected>): Signal<UseLoaderDepsResult<TRouter, TFrom, TSelected>>;
