import { Injector, Signal } from '@angular/core';
import { AnyRouter, RegisteredRouter, RouterState } from '@tanstack/router-core';
import { Observable } from 'rxjs';
export interface LocationBaseOptions<TRouter extends AnyRouter, TSelected> {
    select?: (state: RouterState<TRouter['routeTree']>['location']) => TSelected;
    injector?: Injector;
}
export type LocationResult<TRouter extends AnyRouter, TSelected> = unknown extends TSelected ? RouterState<TRouter['routeTree']>['location'] : TSelected;
export declare function location$<TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>({ injector, select, }?: LocationBaseOptions<TRouter, TSelected>): Observable<LocationResult<TRouter, TSelected>>;
export declare function location<TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>({ injector, select }?: LocationBaseOptions<TRouter, TSelected>): Signal<LocationResult<TRouter, TSelected>>;
