import { Injector } from '@angular/core';
import { AnyRouter, DeepPartial, MakeOptionalPathParams, MakeOptionalSearchParams, MaskOptions, RegisteredRouter, MatchRouteOptions as TanstackMatchRouteOptions, ToSubOptionsProps } from '@tanstack/router-core';
import * as i0 from "@angular/core";
export type MatchRouteOptions<TRouter extends AnyRouter = RegisteredRouter, TFrom extends string = string, TTo extends string | undefined = undefined, TMaskFrom extends string = TFrom, TMaskTo extends string = ''> = ToSubOptionsProps<TRouter, TFrom, TTo> & DeepPartial<MakeOptionalSearchParams<TRouter, TFrom, TTo>> & DeepPartial<MakeOptionalPathParams<TRouter, TFrom, TTo>> & MaskOptions<TRouter, TMaskFrom, TMaskTo> & TanstackMatchRouteOptions & {
    injector?: Injector;
};
export declare function matchRoute$<TRouter extends AnyRouter = RegisteredRouter>({ injector, }?: {
    injector?: Injector;
}): <const TFrom extends string = string, const TTo extends string | undefined = undefined, const TMaskFrom extends string = TFrom, const TMaskTo extends string = "">(opts: MatchRouteOptions<TRouter, TFrom, TTo, TMaskFrom, TMaskTo>) => import("rxjs").Observable<any>;
export declare function matchRoute<TRouter extends AnyRouter = RegisteredRouter>({ injector, }?: {
    injector?: Injector;
}): <const TFrom extends string = string, const TTo extends string | undefined = undefined, const TMaskFrom extends string = TFrom, const TMaskTo extends string = "">(opts: MatchRouteOptions<TRouter, TFrom, TTo, TMaskFrom, TMaskTo>) => import("@angular/core").Signal<any>;
export type MakeMatchRouteOptions<TRouter extends AnyRouter = RegisteredRouter, TFrom extends string = string, TTo extends string | undefined = undefined, TMaskFrom extends string = TFrom, TMaskTo extends string = ''> = MatchRouteOptions<TRouter, TFrom, TTo, TMaskFrom, TMaskTo>;
export declare class MatchRoute<TRouter extends AnyRouter = RegisteredRouter, const TFrom extends string = string, const TTo extends string | undefined = undefined, const TMaskFrom extends string = TFrom, const TMaskTo extends string = ''> {
    matchRoute: import("@angular/core").InputSignal<Partial<MakeMatchRouteOptions<TRouter, TFrom, TTo, TMaskFrom, TMaskTo>>>;
    private status$;
    private matchRouteFn;
    private parentLink;
    private options;
    match$: import("rxjs").Observable<any>;
    match: import("@angular/core").Signal<any>;
    static ɵfac: i0.ɵɵFactoryDeclaration<MatchRoute<any, any, any, any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MatchRoute<any, any, any, any, any>, "[match]", ["matchRoute"], { "matchRoute": { "alias": "match"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
