import { Injector, Signal } from '@angular/core';
import { AnyRouter, MakeRouteMatch, MakeRouteMatchUnion, RegisteredRouter, StrictOrFrom, ThrowConstraint, ThrowOrOptional } from '@tanstack/router-core';
import { Observable } from 'rxjs';
export interface MatchBaseOptions<TRouter extends AnyRouter, TFrom, TStrict extends boolean, TThrow extends boolean, TSelected> {
    select?: (match: MakeRouteMatch<TRouter['routeTree'], TFrom, TStrict>) => TSelected;
    shouldThrow?: TThrow;
    injector?: Injector;
}
export type MatchRoute<TObservable extends boolean, out TFrom> = <TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>(opts?: MatchBaseOptions<TRouter, TFrom, true, true, TSelected>) => TObservable extends true ? Observable<MatchResult<TRouter, TFrom, true, TSelected>> : Signal<MatchResult<TRouter, TFrom, true, TSelected>>;
export type MatchOptions<TRouter extends AnyRouter, TFrom extends string | undefined, TStrict extends boolean, TThrow extends boolean, TSelected> = StrictOrFrom<TRouter, TFrom, TStrict> & MatchBaseOptions<TRouter, TFrom, TStrict, TThrow, TSelected>;
export type MatchResult<TRouter extends AnyRouter, TFrom, TStrict extends boolean, TSelected> = unknown extends TSelected ? TStrict extends true ? MakeRouteMatch<TRouter['routeTree'], TFrom, TStrict> : MakeRouteMatchUnion<TRouter> : TSelected;
export declare function match$<TRouter extends AnyRouter = RegisteredRouter, const TFrom extends string | undefined = undefined, TStrict extends boolean = true, TThrow extends boolean = true, TSelected = unknown>({ injector, ...opts }: MatchOptions<TRouter, TFrom, TStrict, ThrowConstraint<TStrict, TThrow>, TSelected>): Observable<ThrowOrOptional<MatchResult<TRouter, TFrom, TStrict, TSelected>, TThrow>>;
export declare function match<TRouter extends AnyRouter = RegisteredRouter, const TFrom extends string | undefined = undefined, TStrict extends boolean = true, TThrow extends boolean = true, TSelected = unknown>({ injector, ...opts }: MatchOptions<TRouter, TFrom, TStrict, ThrowConstraint<TStrict, TThrow>, TSelected>): Signal<ThrowOrOptional<MatchResult<TRouter, TFrom, TStrict, TSelected>, TThrow>>;
