import { Injector, Signal } from '@angular/core';
import { AnyRouter, MakeRouteMatchUnion, RegisteredRouter } from '@tanstack/router-core';
import { Observable } from 'rxjs';
import * as i0 from "@angular/core";
import * as i1 from "./transitioner";
export declare class Matches {
    private router;
    private injector;
    private vcr;
    private defaultPendingComponent;
    private resetKey$;
    private rootMatchId$;
    private matchLoad$;
    private cmpRef?;
    private run$;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<Matches, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<Matches, never, never, {}, {}, never, never, true, [{ directive: typeof i1.Transitioner; inputs: {}; outputs: {}; }]>;
}
export interface MatchesBaseOptions<TRouter extends AnyRouter, TSelected> {
    select?: (matches: Array<MakeRouteMatchUnion<TRouter>>) => TSelected;
    injector?: Injector;
}
export type MatchesResult<TRouter extends AnyRouter, TSelected> = unknown extends TSelected ? Array<MakeRouteMatchUnion<TRouter>> : TSelected;
export declare function matches$<TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>({ injector, ...opts }?: MatchesBaseOptions<TRouter, TSelected>): Observable<MatchesResult<TRouter, TSelected>>;
export declare function matches<TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>({ injector, ...opts }?: MatchesBaseOptions<TRouter, TSelected>): Signal<MatchesResult<TRouter, TSelected>>;
export declare function parentMatches$<TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>({ injector, ...opts }?: MatchesBaseOptions<TRouter, TSelected>): Observable<MatchesResult<TRouter, TSelected>>;
export declare function parentMatches<TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>({ injector, ...opts }?: MatchesBaseOptions<TRouter, TSelected>): Signal<MatchesResult<TRouter, TSelected>>;
export declare function childMatches$<TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>({ injector, ...opts }?: MatchesBaseOptions<TRouter, TSelected>): Observable<MatchesResult<TRouter, TSelected>>;
export declare function childMatches<TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>({ injector, ...opts }?: MatchesBaseOptions<TRouter, TSelected>): Signal<MatchesResult<TRouter, TSelected>>;
