import { Injector, Signal, type ValueEqualityFn } from '@angular/core';
import { type AnyRouter, type RegisteredRouter, type RouterState } from '@tanstack/router-core';
import { Observable } from 'rxjs';
export type RouterStateResult<TRouter extends AnyRouter, TSelected> = unknown extends TSelected ? RouterState<TRouter['routeTree']> : TSelected;
export type RouterStateOptions<TRouter extends AnyRouter, TSelected> = {
    select?: (state: RouterState<TRouter['routeTree']>) => TSelected;
    equal?: ValueEqualityFn<RouterStateResult<NoInfer<TRouter>, NoInfer<TSelected>>>;
    injector?: Injector;
};
export declare function routerState$<TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>({ select, injector, equal, }: RouterStateOptions<TRouter, TSelected>): Observable<RouterStateResult<TRouter, TSelected>>;
export declare function routerState<TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>({ select, injector, equal, }?: RouterStateOptions<TRouter, TSelected>): Signal<RouterStateResult<TRouter, TSelected>>;
