import { Injector, Signal } from '@angular/core';
import { AnyRouter, RegisteredRouter, ResolveUseSearch, StrictOrFrom, ThrowConstraint, ThrowOrOptional, UseSearchResult } from '@tanstack/router-core';
import { Observable } from 'rxjs';
export interface SearchBaseOptions<TRouter extends AnyRouter, TFrom, TStrict extends boolean, TThrow extends boolean, TSelected> {
    select?: (state: ResolveUseSearch<TRouter, TFrom, TStrict>) => TSelected;
    shouldThrow?: TThrow;
    injector?: Injector;
}
export type SearchOptions<TRouter extends AnyRouter, TFrom, TStrict extends boolean, TThrow extends boolean, TSelected> = StrictOrFrom<TRouter, TFrom, TStrict> & SearchBaseOptions<TRouter, TFrom, TStrict, TThrow, TSelected>;
export type SearchRoute<TObservable extends boolean, out TFrom> = <TRouter extends AnyRouter = RegisteredRouter, TSelected = unknown>(opts?: SearchBaseOptions<TRouter, TFrom, true, true, TSelected>) => TObservable extends true ? Observable<UseSearchResult<TRouter, TFrom, true, TSelected>> : Signal<UseSearchResult<TRouter, TFrom, true, TSelected>>;
export declare function search$<TRouter extends AnyRouter = RegisteredRouter, const TFrom extends string | undefined = undefined, TStrict extends boolean = true, TThrow extends boolean = true, TSelected = unknown>({ injector, ...opts }: SearchOptions<TRouter, TFrom, TStrict, ThrowConstraint<TStrict, TThrow>, TSelected>): Observable<ThrowOrOptional<UseSearchResult<TRouter, TFrom, TStrict, TSelected>, TThrow>>;
export declare function search<TRouter extends AnyRouter = RegisteredRouter, const TFrom extends string | undefined = undefined, TStrict extends boolean = true, TThrow extends boolean = true, TSelected = unknown>({ injector, ...opts }: SearchOptions<TRouter, TFrom, TStrict, ThrowConstraint<TStrict, TThrow>, TSelected>): Signal<ThrowOrOptional<UseSearchResult<TRouter, TFrom, TStrict, TSelected>, TThrow>>;
